/*
 * Gui class
 * by hackervalley@free.fr
 * http://hackervalley.free.fr
 * May 2004
 * this program is licensed under the GPL.
 */
 
#ifndef GUI_H
#define GUI_H

// only for developpement
#include <iostream>
#include <fstream>

// Fltk headers
#include <FL/Fl.H>
#include <FL/Fl_Widget.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Menu_Item.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Multiline_Output.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Return_Button.H>
#include <FL/Fl_File_Chooser.H>

// Handle OpengL
#include <FL/gl.h>
#include <FL/Fl_Gl_Window.H>

extern "C"
{
#include <stdlib.h>
}

#include "OpenGLWindow.hh"

namespace FE
{

	class Gui
	{
	      public:
			  
		// MainWindow
		Fl_Window * mainWindow;

		// MainMenuBar
		Fl_Menu_Bar *mainMenuBar;
	    		  
		//OpenGL RenderWindow     
		OpenGLWindow *glWindow;
		  
		//StatusBar
		Fl_Group *statusBar;
		  
		// GeoBar
		 Fl_Group *geoBar;
		  
		 // about window
		Fl_Window *aboutWindow;

		// Size of MainWindow;        
		int width;
		int height;

		// Constructor
		  Gui ();
		  
		  // Destructor
		  ~Gui();

		// Callbacks
		// File Menu
		static void open_cb(Fl_Widget *, void *);
		void open_cb2(Fl_Widget *, void *);
		
		static void saveas_cb(Fl_Widget *, void *);
		void saveas_cb2(Fl_Widget *, void *);
		
		static void file_quit_cb(Fl_Widget *, void *);
		
		// Help Menu
		static void help_about_cb (Fl_Widget *, void *);
		void help_about_cb2 (Fl_Widget *,void *);
		
		// geoBar callbacks
		static void create_Vertex_cb(Fl_Widget *, void *);
		void create_Vertex_cb2();
		
		// OK Window callback
		static void OK_cb(Fl_Widget *, void *);
		
		// make window
		void create_main_window ();
		void create_about_window ();

		// general interaction
		
		int run ();

	};

}

#endif
