/*
 * OpenGLWindow class
 * by hackervalley@free.fr
 * http://hackervalley.free.fr
 * May 2004
 * this program is licensed under the GPL.
 */

#include "OpenGLWindow.hh"

#include <iostream>

using namespace FE;
using namespace std;

OpenGLWindow::~OpenGLWindow()
{
	delete engine;	
}

void
OpenGLWindow::draw ()
{
// the valid() property may be used to avoid reinitializing your
// GL transformation for each redraw:
	if (!valid ())
	{
		glMatrixMode (GL_PROJECTION);
		glLoadIdentity ();
		glViewport (0, 0, w (), h ());
		glFrustum (-1, 1, -1, 1, -2, 100);

		glMatrixMode (GL_MODELVIEW);
		glLoadIdentity ();
		gluLookAt (0.0, 0.0, 8.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

		glColor3f (1.0, 1.0, 1.0);
		glPointSize (3.0);
		
	}

	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity ();

	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glPushMatrix ();

	// Display Opengl informations
	engine->draw ();
	
	// Display select rectangle
	if ( engine->StateDrawRectangle == true) engine->drawRectangle (engine->x0, engine->y0, engine->x1 , engine->y1);
		
	// Display Move Line
	if (engine->StateMove == true ) engine->DrawMoveLine(engine->x0, engine->y0, engine->x1 , engine->y1);

	glPopMatrix ();
}


int
OpenGLWindow::handle (int event)
{
	int x = Fl::event_x (), y = Fl::event_y ();

	switch (event)
	{
			
	case FL_MOVE:
		cout << "X: " << x << " Y: " << y << endl;
		return(1);
		break;

	case FL_PUSH:
			// Left Mouse Button
		if (Fl::event_button () == 1)
		{
		/* rectangle selection */
		/* Assign corner of rectangle selection */
		engine->x0 = x;
		engine->y0 = y;
		engine->x1 = x;
		engine->y1 = y;
		engine->StateDrawRectangle = true;
		if ( valid() )	redraw ();
					
		if (createvertex == true)
			{
				engine->createvertex (x, y);
				createvertex = false;
				if ( valid() )	redraw ();
			}

			else
			{
				engine->selectvertex (x, y);
				if ( valid() )	redraw ();
			}
			
		}
		
			// Right Mouse Button
		if (Fl::event_button () == 3)
		{
			/* Move */
		engine->x0 = x;
		engine->y0 = y;
		engine->x1 = x;
		engine->y1 = y;
		engine->StateMove = true;
		if ( valid() )	redraw ();
		}
		
		return(1);
		break;
		
	case FL_DRAG:
		// Left Mouse Button
		if (Fl::event_button () == 1)
		{
		/* Assign second corner of rectangle selection */
		engine->x1 = x; 
		engine->y1 = y;
		
		if ( valid() )	redraw ();
		}
		
		// Right Mouse Button
		if (Fl::event_button () == 3)
		{
		/* Move */
		engine->x1 = x; 
		engine->y1 = y;
		
		if ( valid() )	redraw ();
		}
		
		return(1);
		break;
		
	case FL_RELEASE:
		// Left Mouse Button
		if (Fl::event_button () == 1)
		{
			engine->StateDrawRectangle = false;
			engine->RectangleSelectVertex (engine->x0, engine->y0, engine->x1 , engine->y1);
			if ( valid() )	redraw ();
		}
		
		// Right Mouse Button
		if (Fl::event_button () == 3)
		{
			engine->StateMove = false;
			engine->MoveSelected (engine->x0, engine->y0, engine->x1 , engine->y1);
			if ( valid() )	redraw ();
		}
		
		return(1);
		break;

	// To handle keyboard we return(1) 
	case FL_FOCUS:
	case FL_UNFOCUS:
		return(1);
				
	case FL_KEYUP:
		switch (Fl::event_key ())
		{
		case FL_Delete:
			cout << "Delete " << endl;
			engine->DeleteSelectVertex();
			if ( valid() )	redraw ();
			}
		return(1);
		break;
	/*			
	default:
		if ( valid() )	redraw ();
	*/
	}
	return(Fl_Gl_Window::handle (event));

}
